import * as _backstage_plugin_auth_node from '@backstage/plugin-auth-node';
import { PassportOAuthAuthenticatorHelper, PassportProfile, OAuthAuthenticatorResult } from '@backstage/plugin-auth-node';
import * as _backstage_backend_plugin_api from '@backstage/backend-plugin-api';

/** @public */
declare const bitbucketAuthenticator: _backstage_plugin_auth_node.OAuthAuthenticator<PassportOAuthAuthenticatorHelper, PassportProfile>;

/** @public */
declare const authModuleBitbucketProvider: _backstage_backend_plugin_api.BackendFeature;

/**
 * Available sign-in resolvers for the Bitbucket auth provider.
 *
 * @public
 */
declare namespace bitbucketSignInResolvers {
    /**
     * Looks up the user by matching their Bitbucket user ID with the `bitbucket.org/user-id` annotation.
     */
    const userIdMatchingUserEntityAnnotation: _backstage_plugin_auth_node.SignInResolverFactory<OAuthAuthenticatorResult<PassportProfile>, unknown>;
    /**
     * Looks up the user by matching their Bitbucket username with the `bitbucket.org/username` annotation.
     */
    const usernameMatchingUserEntityAnnotation: _backstage_plugin_auth_node.SignInResolverFactory<OAuthAuthenticatorResult<PassportProfile>, unknown>;
}

export { bitbucketAuthenticator, bitbucketSignInResolvers, authModuleBitbucketProvider as default };
